public class Joueur
{
   //
   // Valeurs par dfaut
   //
   private static final int
      BUTS_DFAUT = 0,
      PASSES_DFAUT = 0;
   private static final String
      NOM_DFAUT = "?";
   //
   // Pondration en vue du calcul des points
   //
   private static final int
      PONDRATION_BUTS = 2,
      PONDRATION_PASSES = 1;
   //
   // Attributs
   //
   private String m_Nom;
   private int m_Buts,
               m_Passes;
   //
   // Accesseurs/ manipulateurs pour le nom
   //
   public String GetNom ()
   {
      return m_Nom;
   }
   public void SetNom (final String Nom)
      throws Exception
   {
      if (Nom == null)
         throw new Exception ("Nom ne peut tre nul");
      SetNomBrut (Nom);
   }
   private void SetNomBrut (final String Nom)
   {
      m_Nom = Nom;
   }
   //
   // Accesseurs/ manipulateurs pour les buts et les passes
   //
   public int GetButs ()
   {
      return m_Buts;
   }
   public int GetPasses ()
   {
      return m_Passes;
   }
   private static boolean EstButsValide (final int Buts)
   {
      return Buts >= 0;
   }
   private static boolean EstPassesValide (final int Passes)
   {
      return Passes >= 0;
   }
   public void SetButs (final int Buts)
      throws Exception
   {
      if (!EstButsValide (Buts))
         throw new Exception ("Buts invalides: " + Buts);
      SetButsBrut (Buts);
   }
   public void SetPasses (final int Passes)
      throws Exception
   {
      if (!EstPassesValide (Passes))
         throw new Exception ("Passes invalides: " + Passes);
      SetPassesBrut (Passes);
   }
   private void SetButsBrut (final int Buts)
   {
      m_Buts = Buts;
   }
   private void SetPassesBrut (final int Passes)
   {
      m_Passes = Passes;
   }
   //
   // Politique de calcul des points
   //
   public int GetPoints ()
   {
      return PONDRATION_BUTS * GetButs () +
             PONDRATION_PASSES * GetPasses ();
   }
   //
   // Constructeurs
   //
   public Joueur ()
   {
      SetNomBrut (NOM_DFAUT);
      SetButsBrut (BUTS_DFAUT);
      SetPassesBrut (PASSES_DFAUT);
   }
   public Joueur (final Joueur Original)
   {
      copy (Original);
   }
   public Joueur (final String Nom, final int Buts, final int Passes)
      throws Exception
   {
      SetNom (Nom);
      SetButs (Buts);
      SetPasses (Passes);
   }
   //
   // Comparaison et affectation
   //
   public void copy (final Joueur Original)
   {
      SetNomBrut (Original.GetNom ());
      SetButsBrut (Original.GetButs ());
      SetPassesBrut (Original.GetPasses ());
   }
   public boolean equals (final Joueur Autre)
   {
      return Autre != null &&
             GetNom ().equals (Autre.GetNom ());
   }
}
